#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define vst_bswap32(x) __builtin_bswap32(x)

//static unsigned int vst_bswap32(unsigned int x)
//{
//	return (x>>24) | ((x<<8) & 0x00FF0000) | ((x>>8) & 0x0000FF00) | (x<<24);
//	return __builtin_bswap32 (x);
//}


int main(int argc, char *argv[]) 
{

FILE* fin; 
FILE* fout;

short value;

char filename[1024];
char buffer[1024];
char *dot, *newname;
int len;


long chunkMagic;
long byteSize;
long fxpMagic;
long fxpVersion;
long pluginID;
long pluginVersion;
long numParams;
char prgName[28];
long chunksize;

long totalchunksize;
long swapchunksize;

long size;

int i;

char *nameptr;

nameptr = &filename[0];

for (i=0; i< 1024; i++)
{
*nameptr++ = 0;
}

nameptr = &buffer[0];

for (i=0; i< 1024; i++)
{
*nameptr++ = 0;
}


nameptr = &prgName[0];

for (i=0; i< 28; i++)
{
*nameptr++ = 0;
}


chunkMagic = vst_bswap32('CcnK');

fxpMagic = vst_bswap32('FPCh');

fxpVersion = vst_bswap32(1);

pluginID = vst_bswap32('Podo');

pluginVersion = vst_bswap32(1);

numParams = vst_bswap32(1);


fin = fopen(argv[1], "rb");

if (fin == NULL)
return;

strncpy(filename, argv[1], 1024);

/* Get position of the last dot in the name */

dot = strrchr(filename, '.');

if (dot == NULL)
{
fclose(fin);
return;
}

/* If a dot was found, calculate the length to this point */

len = dot - filename;

strcpy(filename + len, ".fxp");


strncpy(&prgName[0], &filename[0], 28);



if(len < 28)
{
nameptr = &prgName[len];

for (i=0;i<4;i++)
{
*nameptr++ = 0;
}
}


fout = fopen(filename, "wb");

if (fout == NULL)
{
fclose(fin);
return;
}
      
chunksize = 0;

fseek(fin , 0 , SEEK_END);
chunksize = ftell(fin);
rewind(fin);


fwrite(&chunkMagic,  1, 4, fout);
totalchunksize = vst_bswap32(chunksize + 52);
fwrite(&totalchunksize,  1, 4, fout);
fwrite(&fxpMagic ,  1, 4, fout);
fwrite(&fxpVersion ,  1, 4, fout);
fwrite(&pluginID ,  1, 4, fout);
fwrite(&pluginVersion ,  1, 4, fout);
fwrite(&numParams ,  1, 4, fout);
fwrite(&prgName[0] ,  1, 28, fout);

swapchunksize =  vst_bswap32(chunksize);
fwrite(&swapchunksize ,  1, 4, fout);

do {

size = fread(buffer, 1, 1024, fin);

fwrite(buffer, 1, size, fout);

} while (! feof(fin)) ;
 

fclose(fin) ;
fclose(fout) ;

} 

